(*-------------------------------------------------------------------------*)
(*                        NEFCLASS-PC Resource Creator                     *)
(*-------------------------------------------------------------------------*)
(* This program creates a resource file for NEFCLASS-PC. The resource file *)
(* contains the desktop.                                                   *)
(*-------------------------------------------------------------------------*)
(* Filename: NFCL_RES.PAS                                                  *)
(* Programmer: Ulrike Nauck                                                *)
(* Last change: 10/01/95                                                   *)
(*-------------------------------------------------------------------------*)
(* (c) Technical University of Braunschweig, 1994                          *)
(*-------------------------------------------------------------------------*)

program NFCL_Res;

uses NFCL_Con, Drivers, Objects, Views, Menus, Dialogs, Validate, Editors,
     MyValid, App, NFCL_DLG, NFCL_Typ, NFCLHELP;

var
  R: TRect;
  ResFile: TResourceFile;
  MainMenu: PMenuBar;
  StatLine: PStatusLine;
  AboutBox: PDialog;
  LicenceBox: PDialog;
  LearnParamDialog: PLearnParamDialog;
  ControlParamDialog: PControlParamDialog;
  NetParamDialog  : PNetParamDialog;
  PlotDialog      : PPlotDialog;
  RuleDialog      : PRuleDialog;
  NetLabelDialog  : PNetLabelDialog;
  Field: PInputLine;
  Cluster: PCluster;
  Memo: PMemo;

begin
  writeln ('Writing resource file for NEFCON-PC ...');
  RegisterViews;
  RegisterDialogs;
  RegisterMenus;
  RegisterValidate;
  RegisterMyValidate;
  RegisterEditors;
  RegisterMyDialogs;
  ResFile.Init(New(PBufStream, Init('NEFCLASS.TVR', stCreate, 2048)));
  R.Assign(0, 0, 80, 1);
  New(MainMenu, Init(R, NewMenu(
    NewSubMenu('~F~ile',hcFile, NewMenu(
      StdFileMenuItems(
      nil)),
    NewSubMenu('~N~etwork', hcNet, NewMenu(
      NewItem('~N~ew','F4', kbF4, cmNetworkNew, hcNetNew,
      NewItem('~C~hange','', kbNoKey, cmNetworkChange, hcNetChange,
      NewItem('~D~isplay','', kbNoKey, cmNetworkDisplay, hcNetDisplay,
      NewLine(
      NewItem('~L~oad...','F6', kbF6, cmNetworkLoad, hcNetLoad,
      NewItem('~S~ave','F5', kbF5, cmNetworkSave, hcNetSave,
      NewItem('Save ~A~s...','', kbNoKey, cmNetworkSaveAs, hcNetSave,
      NewLine(
      NewItem('~E~dit Rules','', kbNoKey, cmNetEditRules, hcEditRules,
      NewItem('Save ~R~ules','', kbNoKey, cmNetworkRules, hcNetRules,
      NewLine(
      NewItem('Des~c~ription','', kbNoKey, cmNetworkLabel, hcNetLabel,
      nil))))))))))))),
    NewSubMenu('~P~attern', hcPattern, NewMenu(
      NewItem('~L~oad...','F7', kbF7, cmPatternLoad, hcPatLoad,
      Newline(
      NewItem('~D~isplay','', kbNoKey, cmPatternDisplay, hcPatDisplay,
      nil)))),
    NewSubMenu('~R~un', hcRun, NewMenu(
      NewItem ('Learning ~C~ontrol', '', kbNoKey, cmRunControl, hcControl,
      NewItem ('Learning ~P~arameters', '', kbNoKey, cmRunParam, hcRunParam,
      NewLine (
      NewItem ('Start ~L~earning', 'F8', kbF8, cmRunLearn, hcRunLearn,
      NewLine(
      NewItem ('~T~est Network', '', kbNoKey, cmRunTest, hcRunTest,
      NewItem ('~S~tatistics', '', kbNoKey, cmRunStats, hcRunStats,
      nil)))))))),
    NewSubMenu('~E~dit', hcEditor, NewMenu(
      StdEditMenuItems(
      NewLine(
      NewItem('~S~how clipboard', '', kbNoKey, cmClipShow, hcEditor,
      nil)))),
    NewSubMenu('~W~indow', hcWindows, NewMenu(
      StdWindowMenuItems(nil)),
    NewSubMenu('~H~elp', hcHelp, NewMenu(
      NewItem('~H~elp Index', '', kbNoKey, cmHelp, hcNoContext,
      NewItem('~A~bout', '', kbNoKey, cmAbout, hcHelpAbout,
      NewItem('~L~icense', '', kbNoKey, cmLicence, hcHelpLicence,
      NewItem('~M~emory', '', kbNoKey, cmHeapSituation, hcHelpMemory,
      nil))))),
    nil))))))))));
  ResFile.Put(MainMenu, 'MAINMENU');

  R.Assign(0, 24, 80, 25);
  New(StatLine, Init(R,
    NewStatusDef(0, $EFFF,
      NewStatusKey('~F1~ Help', kbF1, cmHelp,
      NewStatusKey('~F4~ NewNet', kbF4, cmNetworkNew,
      NewStatusKey('~F5~ SaveNet', kbF5, cmNetworkSave,
      NewStatusKey('~F6~ LoadNet', kbF6, cmNetworkLoad,
      NewStatusKey('~F7~ LoadPat.', kbF7, cmPatternLoad,
      NewStatusKey('~F8~ Learn', kbF8, cmRunLearn,
      NewStatusKey('~Alt+X~ Quit', kbAltX, cmQuit,
      StdStatusKeys(nil)))))))),
    NewStatusDef ($F000, $FFFF,
      StdStatusKeys(nil),
    nil ))));
  ResFile.Put(StatLine, 'STATUS');

(*-------------------------------------------------------------------------*)
(*                            About-Box                                    *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 63, 20);
  AboutBox := New(PDialog, Init(R, 'About NEFCLASS-PC'));
  with AboutBox^ do
  begin
    HelpCTX := hcAbout;
    Options := Options or ofCentered;
    R.Assign(4, 2, 58, 5);
    Insert(New(PStaticText,
           Init(R, #3'NECLASS-PC'#13#13#3'Neuro-Fuzzy Classification')));
    R.Assign(4, 6, 58, 8);
    Insert(New(PStaticText,
           Init(R, #3'Version '+VersionString+
                   #13#3+DateString)));

    R.Assign(2, 9, 62, 12);
    Insert(New(PStaticText,
           Init(R, 'NEFCLASS  Model  and  Algorithms by: Dr. Detlef Nauck'#13+
                   'Programming  and  User Interface by: Ulrike Nauck'#13+
                   'Fuzzy Systems Research Group led by: '+
                   'Prof. Dr. Rudolf Kruse')));

    R.Assign(4, 13, 58, 16);
    Insert(New(PStaticText,
           Init(R, #3'Copyright 1995'#13#3+
                   'Research Group "Fuzzy Systems and '+
                   'Soft Computing"'#13#3+
                   'Technical University of Braunschweig')));
    R.Assign(25, 17, 35, 19);
    Insert(New(PButton, Init(R, 'O~k~', cmOk, bfDefault)));
  end;
  ResFile.Put(AboutBox, 'ABOUTBOX');

(*-------------------------------------------------------------------------*)
(*                            Licence-Box                                  *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 72, 22);
  LicenceBox := New(PDialog, Init(R, 'Licence'));
  with LicenceBox^ do
  begin
    HelpCTX := hcLicence;
    Options := Options or ofCentered;
    R.Assign(4, 2, 68, 3);
    Insert(New(PStaticText,
           Init(R, #3'NEFCLASS-PC '+VersionString+
                    ', '+DateString)));
    R.Assign(2, 3, 70, 4);
    Insert(New(PStaticText,
           Init(R, #3'EXCLUSION OF WARRANTY AND RESTRICTED LICENCE')));
    R.Assign(2, 5, 70, 7);
    Insert(New(PStaticText, Init(R,
    #3'NEFCLASS-PC COMES WITHOUT ANY WARRANTY! USE THIS'#13+
    #3'SOFTWARE AT YOUR OWN RISK ONLY!')));
    R.Assign(2, 7, 70, 9);
    Insert(New(PStaticText, Init(R,
    #3'NEFCLASS-PC is copyrighted by Technische Universitaet Braunschweig,'#13+
    #3'Institut fuer Betriebssysteme und Rechnerverbund.')));
    R.Assign(2, 10, 70, 13);
    Insert(New(PStaticText, Init(R,
    'You may use this software for scientific or educational purposes'#13+
    'only. You may give away copies of this software, but you are not'#13+
    'allowed to charge anything for the software itself.')));
    R.Assign(2, 13, 70, 14);
    Insert(New(PStaticText, Init(R,
    'You may not use this software for commercial purposes of any kind.')));
    R.Assign(2, 15, 70, 18);
    Insert(New(PStaticText, Init(R,
    'For more information, questions, or bug reports please send email to'#13+
    'nauck@ibr.cs.tu-bs.de. Please also read the accompanying README and'#13+
    'LICENCE files.')));
    R.Assign(30, 19, 40, 21);
    Insert(New(PButton, Init(R, 'O~k~', cmOk, bfDefault)));
  end;
  ResFile.Put(LicenceBox, 'LICENCEBOX');

(*-------------------------------------------------------------------------*)
(*           Dialog box for learning control parameters                    *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 44, 13);
  ControlParamDialog := New(PControlParamDialog,
                            Init(R, 'Learning Control Parameters'));
  with ControlParamDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := hcControlDialog;

    R.Assign(28, 2, 38, 3);
    Epochs := New(PInputLine, Init(R, 10));
    Epochs^.SetValidator(New(PRangeValidator, Init(1, MaxLongInt)));
    Insert(Epochs);
    R.Assign(2, 2, 23, 3);
    Insert(New(PLabel, Init(R, '~N~umber of Epochs:', Epochs)));

    R.Assign(28, 3, 38, 4);
    StopError := New(PInputLine, Init(R, 10));
    StopError^.SetValidator(New(PFRangeValidator, Init(0, 10)));
    Insert(StopError);
    R.Assign(2, 3, 23, 4);
    Insert(New(PLabel, Init(R, 'Stop at ~E~rror Value:', StopError)));

    R.Assign(28, 4, 38, 5);
    NofError := New(PInputLine, Init(R, 10));
    NofError^.SetValidator(New(PRangeValidator, Init(0, MaxLongInt)));
    Insert(NofError);
    R.Assign(2, 4, 27, 5);
    Insert(New(PLabel, Init(R, '~M~ax. Number of Errors:', NofError)));

    R.Assign(28, 5, 35, 6);
    Update := New(PInputLine, Init(R, 5));
    Update^.SetValidator(New(PRangeValidator, Init(1, MaxLongInt)));
    Insert(Update);
    R.Assign(2, 5, 25, 6);
    Insert(New(PLabel, Init(R, '~U~pdate Screen/Log each:', Update)));
    R.Assign(36, 5, 42, 6);
    Insert(New(PStaticText, Init(R, 'Epochs')));

    R.Assign(3, 7, 38, 8);
    StopCriterion := New(PCheckBoxes, Init(R,
    NewSItem('~S~top, if minimal error is not', nil)));
    Insert(StopCriterion);

    R.Assign(8, 8, 24, 9);
    Insert (New(PStaticText, Init(R, 'decremented for')));
    R.Assign(24, 8, 32, 9);
    ErrorEpochs := New(PInputLine, Init(R, 6));
    ErrorEpochs^.SetValidator(New(PRangeValidator, Init(1, MaxLongInt)));
    Insert(ErrorEpochs);
    R.Assign(32, 8, 39, 9);
    Insert(New(PLabel, Init(R, 'E~p~ochs', ErrorEpochs)));

    (* buttons *)

    R.Assign(4, 10, 14, 12);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(17, 10, 27, 12);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(30, 10, 40, 12);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));


  end; (* with ControlParamDialog^ *)
  ResFile.Put(ControlParamDialog, 'CONTROL');


(*-------------------------------------------------------------------------*)
(*                   Dialog box for learning parameters                    *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 75, 15);
  LearnParamDialog := New(PLearnParamDialog, Init(R, 'Learning Parameters'));
  with LearnParamDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := hcParamDialog;

    R.Assign(3, 1, 27, 2);
    Insert(New(PStaticText, Init(R, 'Fuzzy Set Constraints')));
    R.Assign(3, 2, 27, 3);
    Insert(New(PStaticText, Init(R, '-')));

    R.Assign(28, 3, 45, 4);
    NoPassing := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(NoPassing);
    R.Assign(2, 3, 25, 4);
    Insert(New(PLabel, Init(R, 'Do Not ~P~ass Neighbors:', NoPassing)));

    R.Assign(28, 4, 45, 5);
    Asymmetrical := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(Asymmetrical);
    R.Assign(2, 4, 24, 5);
    Insert(New(PLabel, Init(R, '~L~earn Asymmetrically:', Asymmetrical)));

    R.Assign(28, 5, 45, 6);
    Intersect := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(Intersect);
    R.Assign(2, 5, 23, 6);
    Insert(New(PLabel, Init(R, '~F~S Intersect at 0.5:', Intersect)));

    R.Assign(28, 6, 45, 7);
    FixedConc := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(FixedConc);
    R.Assign(2, 6, 23, 7);
    Insert(New(PLabel, Init(R, 'Fixed ~C~onclusions:', FixedConc)));

    R.Assign(28, 7, 45, 8);
    UnitConc := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(UnitConc);
    R.Assign(2, 7, 24, 8);
    Insert(New(PLabel, Init(R, 'C~o~nclusions in [0,1]:', UnitConc)));

    R.Assign(28, 9, 70, 10);
    RuleCreation := New(PRadioButtons, Init(R,
      NewSItem('Simple',
      NewSItem('Best',
      NewSItem('Best per Class', nil)))));
    Insert(RuleCreation);
    R.Assign(2, 9, 27, 10);
    Insert(New(PLabel, Init(R, '~R~ule Learning Procedure:', RuleCreation)));

    R.Assign(28, 10, 70, 11);
    ReLearnRules := New(PRadioButtons, Init(R,
      NewSItem('Yes',
      NewSItem('No', nil))));
    Insert(ReLearnRules);
    R.Assign(2, 10, 27, 11);
    Insert(New(PLabel, Init(R, 'Relearn the Rule ~B~ase:', ReLearnRules)));

 (* 2nd row *)

    R.Assign(49, 2, 65, 3);
    Insert(New(PStaticText, Init(R, 'Learning rates')));
    R.Assign(49, 3, 65, 4);
    Insert(New(PStaticText, Init(R, '')));

    R.Assign(60, 4, 70, 5);
    sigma_a := New(PInputLine, Init(R, 10));
    sigma_a^.SetValidator(New(PFRangeValidator, Init(0, 10)));
    Insert(sigma_a);
    R.Assign(48, 4, 57, 5);
    Insert(New(PLabel, Init(R, 'sigma_~a~:', sigma_a)));

    R.Assign(60, 5, 70, 6);
    sigma_b := New(PInputLine, Init(R, 10));
    sigma_b^.SetValidator(New(PFRangeValidator, Init(0, 10)));
    Insert(sigma_b);
    R.Assign(48, 5, 57, 6);
    Insert(New(PLabel, Init(R, 'sigma_~b~:', sigma_b)));

    R.Assign(60, 6, 70, 7);
    sigma_c := New(PInputLine, Init(R, 10));
    sigma_c^.SetValidator(New(PFRangeValidator, Init(0, 10)));
    Insert(sigma_c);
    R.Assign(48, 6, 57, 7);
    Insert(New(PLabel, Init(R, 'sigma_~c~:', sigma_c)));

    R.Assign(60, 7, 70, 8);
    sigma := New(PInputLine, Init(R, 10));
    sigma^.SetValidator(New(PFRangeValidator, Init(0, 10)));
    Insert(sigma);
    R.Assign(48, 7, 57, 8);
    Insert(New(PLabel, Init(R, 's~i~gma:', sigma)));

    (* buttons *)

    R.Assign(17, 12, 27, 14);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(32, 12, 42, 14);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(47, 12, 57, 14);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));

  end; (* with LearnParamDialog^ *)
  ResFile.Put(LearnParamDialog, 'PARAMETER');

(*-------------------------------------------------------------------------*)
(*                      Dialog box for net parameters                      *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 60, 18);
  NetParamDialog := New(PNetParamDialog, Init(R, 'Network Parameters'));
  with NetParamDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := $F000;

    R.Assign (2, 1, 11, 2);
    Insert (New(PStaticText, Init(R, 'Number of')));
    R.Assign (15, 2, 25, 3);
    InLayer := New(PInputLine, Init(R, 10));
    InLayer^.SetValidator(New(PRangeValidator, Init(1, maxunits)));
    Insert(InLayer);
    R.Assign(1, 2, 15, 3);
    Insert(New(PLabel, Init(R, '~i~nput units :', InLayer)));

    R.Assign(15, 3, 25, 4);
    RuleLayer := New(PInputLine, Init(R, 10));
    RuleLayer^.SetValidator(New(PRangeValidator, Init(1, RuleLimit)));
    Insert(RuleLayer);
    R.Assign(1, 3, 15, 4);
    Insert(New(PLabel, Init(R, '~r~ule units  :', RuleLayer)));

    R.Assign(15, 4, 25, 5);
    OutLayer := New(PInputLine, Init(R, 10));
    OutLayer^.SetValidator(New(PRangeValidator, Init(1, maxunits)));
    Insert(OutLayer);
    R.Assign(1, 4, 15, 5);
    Insert(New(PLabel, Init(R, 'out~p~ut units:', OutLayer)));

    R.Assign(2, 7, 20, 9);
    UseSum := New(PRadioButtons, Init(R,
      NewSItem('Weighted Sum',
      NewSItem('Maximum', nil))));
    Insert(UseSum);
    R.Assign(1, 6, 23, 7);
    Insert(New(PLabel, Init(R, '~A~ggregation function:', UseSum)));

    R.Assign(28, 2, 52, 4);
    Individual := New(PRadioButtons, Init(R,
      NewSItem('same for all units:',
      NewSItem('individually:', nil))));
    Insert(Individual);
    R.Assign(27, 1, 49, 2);
    Insert(New(PLabel, Init(R, 'Number of ~F~uzzy Sets:', Individual)));

    R.Assign(52, 2, 57, 3);
    Partition := New(PInputLine, Init(R, 5));
    Partition^.SetValidator(New(PRangeValidator, Init(1, maxfs)));
    Insert(Partition);

    R.Assign(32, 6, 42, 7);
    Picked := New(PInputLine, Init(R, 9));
    Insert(Picked);
    R.Assign(31, 5, 42, 6);
    Insert(New(PLabel, Init(R, 's~e~lected:', Picked)));

    R.Assign(43, 6, 48, 7);
    IndFSets := New(PInputLine, Init(R, 5));
    IndFSets^.SetValidator(New(PRangeValidator, Init(1, maxfs)));
    Insert(IndFSets);

    R.Assign(42, 5, 51, 6);
    Insert(New(PLabel, Init(R, '~#~f-sets:', IndFSets)));
    R.Assign(48, 6, 55, 8);
    Insert(New(PButton, Init(R, '~s~et', cmFSet, bfNormal)));

    R.Assign(42, 8, 43, 12);
    New(ScrollBar, Init(R));
    Insert(ScrollBar);
    R.Assign(32, 8, 42, 12);
    UnitList := New(PPartList, Init(R, 1, ScrollBar));
    Insert(UnitList);

    R.Assign(14, 12, 24, 13);
    ClassPicked := New(PInputLine, Init(R, 9));
    Insert(ClassPicked);

    R.Assign(13, 10, 20, 12);
    Insert(New(PButton, Init(R, 'se~t~', cmCSet, bfNormal)));

    R.Assign(12, 11, 13, 14);
    New(ScrollBar, Init(R));
    Insert(ScrollBar);
    R.Assign( 2, 11, 12, 14);
    ClassList := New(PMyListBox, Init(R, 1, ScrollBar));
    Insert(ClassList);

    R.Assign ( 1, 10, 14, 11);
    Insert (New (PLabel, Init (R, 'C~l~ass Names', ClassList)));

    (* buttons *)

    R.Assign( 2, 15, 12, 17);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(17, 15, 27, 17);
    Insert(New(PButton, Init(R, '~W~eights', cmYes, bfNormal)));
    R.Assign(32, 15, 42, 17);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(47, 15, 57, 17);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));

  end; (* with NetParamDialog^ *)
  ResFile.Put(NetParamDialog, 'NETPARAM');

(*-------------------------------------------------------------------------*)
(*           Dialog box for plotting control parameters                    *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 45, 13);
  PlotDialog := New(PPlotDialog,
                    Init(R, 'Plotting Projections or Bar Charts'));
  with PlotDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := hcPlotParams;

    R.Assign(33, 2, 43, 3);
    V1 := New(PInputLine, Init(R, 10));
    V1^.SetValidator(New(PRangeValidator, Init(1, maxunits)));
    Insert(V1);
    R.Assign(2, 2, 31, 3);
    Insert(New(PLabel, Init(R, 'Feature for ~f~irst dimension:', V1)));

    R.Assign(33, 4, 43, 5);
    V2 := New(PInputLine, Init(R, 10));
    V2^.SetValidator(New(PRangeValidator, Init(1, maxunits)));
    Insert(V2);
    R.Assign(2, 4, 32, 5);
    Insert(New(PLabel, Init(R, 'Feature for ~s~econd dimension:', V2)));

    R.Assign(2, 6, 20, 8);
    PlotSelect := New(PRadioButtons, Init(R,
      NewSItem('Projections',
      NewSItem('Bar Charts', nil))));
    Insert(PlotSelect);

    (* buttons *)

    R.Assign(4,  10, 14, 12);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(17, 10, 27, 12);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(30, 10, 40, 12);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));

  end; (* with ControlParamDialog^ *)
  ResFile.Put(PlotDialog, 'PLOT');

(*-------------------------------------------------------------------------*)
(*                      Dialog box for editing rules                       *)
(*-------------------------------------------------------------------------*)

  R.Assign(0, 0, 60, 19);
  RuleDialog := New(PRuleDialog, Init(R, 'Fuzzy Rules'));
  with RuleDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := hcRuleEditDialog;

    R.Assign(41, 2, 42, 7);
    New(AScrollBar, Init(R));
    Insert(AScrollBar);
    R.Assign(15, 2, 41, 7);
    AntecList := New(PListBox, Init(R, 1, AScrollBar));
    Insert(AntecList);
    R.Assign (14, 1, 17, 2);
    Insert (New (PLabel, Init (R, '~I~F', AntecList)));

    R.Assign(48, 2, 58, 3);
    Class := New(PInputLine, Init(R, 10));
    Insert (Class);
    R.Assign (47, 1, 52, 2);
    Insert (New (PLabel, Init (R, '~T~HEN', Class)));

    R.Assign( 47, 4, 58, 6);
    Insert(New(PButton, Init(R, '~N~ew', cmEnterRule, bfNormal)));
    R.Assign( 47, 6, 58, 8);
    Insert(New(PButton, Init(R, '~D~elete', cmDeleteRule, bfNormal)));

    R.Assign(8, 2, 9, 7);
    New(RScrollBar, Init(R));
    Insert(RScrollBar);
    R.Assign( 2, 2, 8, 7);
    RuleList := New(PRuleList, Init(R, 1, RScrollBar));
    Insert(RuleList);
    R.Assign ( 1, 1, 7, 2);
    Insert (New (PLabel, Init (R, '~R~ule', RuleList)));

    R.Assign(25, 9, 26, 14);
    New(FScrollBar, Init(R));
    Insert(FScrollBar);
    R.Assign(15, 9, 25, 14);
    FSetList := New(PListBox, Init(R, 1, FScrollBar));
    Insert(FSetList);
    R.Assign (14, 8, 26, 9);
    Insert (New (PLabel, Init (R, '~F~uzzy Set', FSetList)));

    R.Assign( 26, 9, 36, 11);
    Insert(New(PButton, Init(R, '~A~dd', cmEnterAntec, bfNormal)));
    R.Assign( 26, 11, 36, 13);
    Insert(New(PButton, Init(R, '~D~elete', cmDeleteAntec, bfNormal)));
    R.Assign( 26, 13, 36, 15);
    Insert(New(PButton, Init(R, '~M~odify', cmModifyAntec, bfNormal)));

    R.Assign(12, 9, 13, 14);
    New(VScrollBar, Init(R));
    Insert(VScrollBar);
    R.Assign( 2, 9, 12, 14);
    VarList := New(PMyListBox, Init(R, 1, VScrollBar));
    Insert(VarList);
    R.Assign ( 1, 8, 12, 9);
    Insert (New (PLabel, Init (R, '~V~ariable', VarList)));

    R.Assign(50, 9, 51, 14);
    New(CScrollBar, Init(R));
    Insert(CScrollBar);
    R.Assign(40, 9, 50, 14);
    ClassList := New(PListBox, Init(R, 1, CScrollBar));
    Insert(ClassList);
    R.Assign (39, 8, 46, 9);
    Insert (New (PLabel, Init (R, '~C~lass', ClassList)));

    R.Assign( 51, 9, 58, 11);
    Insert(New(PButton, Init(R, '~S~et', cmSetRuleClass, bfNormal)));

    R.Assign( 8, 16, 18, 18);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(25, 16, 35, 18);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(42, 16, 52, 18);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));


  end; (* with RuleDialog^ *)
  ResFile.Put(RuleDialog, 'RULES');

(*-------------------------------------------------------------------------*)
(*                      Dialog box for labeling a network                  *)
(*-------------------------------------------------------------------------*)
  R.Assign(0, 0, 45, 10);
  NetLabelDialog := New(PNetLabelDialog, Init(R, 'Network Description'));
  with NetLabelDialog^ do
  begin
    Options := Options or ofCentered;
    HelpCtx := hcNetLabelDialog;
    R.Assign(2, 2, 36, 4);
    Insert(New(PStaticText, Init(R,
    'You can enter up to 80 characters'#13+
    'to describe the current network. '#13)));
    R.Assign(2, 5, 42, 6);
    NetLabel := New(PInputLine, Init(R, 80));
    Insert (NetLabel);

    R.Assign( 4, 7, 14, 9);
    Insert(New(PButton, Init(R, '~O~k', cmOk, bfDefault)));
    R.Assign(17, 7, 27, 9);
    Insert(New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    R.Assign(30, 7, 40, 9);
    Insert(New(PButton, Init(R, '~H~elp', cmHelp, bfNormal)));

  end; (* with NetLabelDialog^ *)
  ResFile.Put(NetLabelDialog, 'NETLABEL');


  ResFile.Done;
  writeln ('done.');
end.
